<template>
    <v-row>
        <v-col cols="6" v-for="(receipt, index) in receipts" :key="index">
            <v-card elevation="2" outlined :color="receiptColor(receipt.category)">
                <div class="uploadedContainer">
                    <v-btn
                        class="closeUploaded"
                        color="error"
                        dark
                        fab
                        @click="$emit('remove', index)"
                        >
                        <font-awesome-icon icon="times" size="2x" /></v-btn>
                        <v-img class="uploadedImage" aspect-ratio="1" :src="receipt.image" @click="showFullScreen(receipt.image)">
                            <template v-slot:placeholder>
                                <v-row
                                class="fill-height ma-0"
                                align="center"
                                justify="center"
                                >
                                <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>
                                </v-row>
                            </template>
                        </v-img>
                </div>
                <v-card-title v-text="formatAmount(receipt.amount)"></v-card-title>
            </v-card>
        </v-col>
        <v-col cols="12" v-if="receipts && receipts.length === 0">
            <v-card class="pa-5" elevation="2" outlined :style="{ backgroundColor: '#e2e0e2' }">
                <div class="text-center text-h3 nothingYet ma-5">
                    {{ $t("receipt.nothingYet") }}<br/><br/>
                    <font-awesome-icon color="grey" icon="upload" size="2x" />

                </div>
            </v-card>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Component, Inject, Prop, Vue } from 'vue-property-decorator'
import { expenditureTypes, expenditureColors } from "@/utils/categories"
import { formatAmount } from "@/utils/price"
import { Receipt } from "@/types/calendar"
import { Observer } from "mobx-vue";
import { RootStore } from "@/store"

@Observer
@Component({})
export default class Day extends Vue {
    public expenditureTypes: Array<string> = expenditureTypes
    @Prop({ default: "2021-08-01", type: String }) public day!: string
    @Prop({ default: [] }) receipts!: Receipt[]
    private dialog: boolean = false
    private expenditureColors: string[] = expenditureColors
    private fullScreenImage: string = ""
    @Inject("root") root !: RootStore
    private loading: boolean = false;

    private formatAmount(amount: number) {
        return formatAmount(amount);
    }

    private showFullScreen(image: string) {
        this.dialog = !this.dialog;
        this.fullScreenImage = image;
    }

    private receiptColor(expenditureType: string) {
        const idx = expenditureTypes.indexOf(expenditureType);
        return this.expenditureColors[idx];
    }
}

</script>

<style scoped>
.dayContainer {
    width: 100%;
    height: 100%;
}
.uploadedContainer {
    width: 100%;
    height: 100%;
    position: relative;
    display: inline-block;
}

.closeUploaded {
    position: absolute;
    top: 5px;
    left: 5px;
    z-index: 2;

}

.uploadedImage {
    z-index: 1;
    height: 100%;
    width: 100%;
}

.nothingYet {
    color: #878787;
    margin: 50px;
}
</style>
